//------------------------------------------
//  -MLink.OPC-
//    COM- 
//  DDE (  )
//
// RAMEDIA-SOFT
// Author:   
// H-page: http://raxp.radioliga.com
// C : win32
//------------------------------------------
unit mm;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,dialogs,StdCtrls, ExtCtrls,
  RXShell,Menus,Grids, DdeMan, ComCtrls, inifiles,ActiveX,
  CPort,CPortCtl,OpcServerCom,itemOPC,rymenus,Graphics, DB, DBClient,ScktComp;

type
  Tmf = class(TForm)
    Timer1: TTimer;
    com: TComPort;
    TI: TRxTrayIcon;
    pm1: TPopupMenu;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    see: TMenuItem;
    p1: TPanel;
    p2: TPanel;
    p3: TPanel;
    ind2: TShape;
    cdp: TComDataPacket;
    sl1: TStringGrid;
    GET: TDdeServerConv;
    DATATM: TDdeServerItem;
    p4: TLabel;
    Bevel1: TBevel;
    sb1: TImage;
    sb2: TImage;
    sb3: TImage;
    bd: TClientDataSet;
    bds: TDataSource;
    opt: TMenuItem;
    en_bd: TMenuItem;
    en_dde: TMenuItem;
    en_tcp: TMenuItem;
    tcp: TServerSocket;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    //procedure comError(Sender: TObject; Errors: TComErrors);
    procedure Help1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure seeClick(Sender: TObject);
    procedure p1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure p1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TIClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure cdpCustomStop(Sender: TObject; const Str: String;
      var Pos: Integer);
    procedure DATATMPokeData(Sender: TObject);
    procedure en_bdClick(Sender: TObject);
    procedure en_tcpClick(Sender: TObject);
    procedure tcpClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure tcpClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private declarations }
    OtherDrawer: TRyMenu;// XP
    ini: TIniFile;

    procedure seeh;
    procedure rec_bd;
    procedure to_pokedata(Sender: TObject);
    procedure ch_create(col: integer);
  public
  end;

var mf: Tmf;
    fl_see: boolean=false;
    OrgP,OrgXY: tPoint;

    //-
    DATAI: array of TDdeServerItem;
    life: boolean=FALSE;
    
implementation

{$R *.DFM}

procedure Tmf.Timer1Timer(Sender: TObject);
var t: tstringlist;
    i: integer;
begin
 inc(chann3); if chann3>100 then chann3:=0; //-
 pulsetimer;

 //DDE-
 if en_dde.Checked then begin
  t:= tstringlist.Create;
  t.Add(floattostr(chann3));
  DATATM.Lines:= t;
  t.Free;
  //  -
  t:= tstringlist.Create;
  t.Add(floattostr(chann3));
  for i:=low(DATAI) to high(DATAI) do
   DATAI[i].Lines:= t;
  t.Free;
 end;

 //-
 if com.Connected then begin
  p3.caption:=' : '+intToStr(clients);
  p4.caption:='COM-232 YES ('+copy(com.Port,4,length(com.Port))+')';
  ind2.Brush.Color:= 65280;
 end else begin
  p3.caption:=' : '+intToStr(clients);
  p4.caption:='COM-232 NOT ('+copy(com.Port,4,length(com.Port))+')';
  ind2.Brush.Color:= 16777215;
 end
end;

//=========================
//select-
function sel_getname(s:shortstring;p:smallint):shortstring;
var i,ii,k,kk:smallint;
begin
 ii:=0;
 for i:=1 to length(s) do
  begin
   if (s[i]='#') then
    begin
     inc(ii);if ii=p then begin
      k:=i;break;end;
    end;
  end;
 for i:=k+1 to length(s) do
  begin
   if (s[i]='#') then
    begin
     kk:=i;break;
    end else kk:=length(s)+1;
  end;
 //
 result:=copy(s,k+1,kk-k-1)
end;
//=========================
procedure Tmf.FormCreate(Sender: TObject);
var i,j: integer;
begin
 SetWindowLong(Application.Handle,GWL_EXSTYLE,GetWindowLong(Application.Handle, GWL_EXSTYLE) or
  not WS_EX_APPWINDOW);
 application.ShowMainForm:=false;
 //-
 RyMenu.Add(pm1, nil);
 OtherDrawer:=TRyMenu.Create;

 //-
 ini:= TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 left:= ini.ReadInteger('SERVER','left',0);
 top := ini.ReadInteger('SERVER','top',0);

 // BD-
 en_bd.Checked:= ini.ReadBool('BD','active',false);
 bd.FileName:= ini.ReadString('BD','name','bd.cds');
 if (en_bd.Checked)and(fileexists(bd.FileName)) then bd.LoadFromFile(bd.FileName);
 // DDE-
 en_dde.Checked:= ini.ReadBool('DDE','active',false);
 if en_dde.Checked then begin
  DATATM.CopyToClipboard; DATATM.ServerConv:= GET;
  //ch_create(trunc(ch_count.value));
 end;

 //COM-
 com.BaudRate := cport.StrToBaudRate(ini.ReadString('COM','BaudRate','19200'));
 com.Port     := ini.ReadString('COM','Port','COM1');
 com.Connected:= ini.ReadBool('COM','Active',false);

 //Socket-
 tcp.Port      := ini.ReadInteger('SOCKET','Port',8765);
 en_tcp.Checked:= ini.ReadBool('SOCKET','Active',false); en_tcp.OnClick(nil);

 // -
 sl1.Cells[0,0]:=' Adr';sl1.Cells[1,0]:=' Chann';sl1.Cells[2,0]:=' Name';
 for i:=1 to ini.ReadInteger('CHANN','count',0) do begin //
  for j:=0 to sl1.ColCount-1 do //
   sl1.Cells[j,i]:= sel_getname(ini.ReadString('CHANN',inttostr(i),''),j+1);
  sl1.RowCount   := sl1.RowCount+1;
 end; if sl1.Cells[0,1]<>'' then sl1.RowCount:= sl1.RowCount-1;
 // -
 for i:=1 to sl1.RowCount-1 do
  if sl1.Cells[0,1]<>'' then add(sl1.Cells[2,i],VT_UI2);
end;

// -
procedure tmf.seeh;
begin
 if fl_see then begin
  show; setforegroundwindow(Handle)
 end else hide
end;


procedure Tmf.Help1Click(Sender: TObject);
const about='TOP-03:  OPC 1.0 (2)'#13#13+
            '-21'#13+
            'e-mail: raxp@mail.zp.ua'#13+
            '--------------'#13+
            '2006';
begin
 messagebox(handle,pchar(about),'about...',MB_ICONINFORMATION)
end;

procedure Tmf.Exit1Click(Sender: TObject);
begin
 close
end;

procedure Tmf.seeClick(Sender: TObject);
begin
 fl_see:=not fl_see;
 seeh
end;

procedure Tmf.p1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var _p : TPoint;
begin
 if Shift = [ssLeft] then
  begin
   _p := ClientToScreen(Point(X, Y));
   SetBounds(OrgP.X + (_p.X - OrgXY.X),
    OrgP.Y + (_p.Y - OrgXY.Y), Width, Height);
  end
end;

procedure Tmf.p1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 OrgP := Point(Left, Top);
 OrgXY:= ClientToScreen(Point(X, Y))
end;

procedure Tmf.TIClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 fl_see:=not fl_see;
 seeh
end;

procedure Tmf.FormDestroy(Sender: TObject);
var s  : string;
    i,j: integer;
begin
 //-
 ini.WriteInteger('SERVER','left',left);
 ini.WriteInteger('SERVER','top',top);
 ini.WriteBool('BD','active',en_bd.Checked);
 ini.WriteString('BD','name',bd.FileName);
 ini.WriteBool('DDE','active',en_dde.Checked);

 ini.WriteString('COM','BaudRate',cport.BaudRateToStr(com.BaudRate));
 ini.WriteString('COM','Port',com.Port);
 ini.WriteBool('COM','Active',com.Connected);

 ini.WriteBool('SOCKET','Active',tcp.Active);
 ini.WriteInteger('SOCKET','Port',tcp.Port);

 // -
 ini.EraseSection('CHANN');
 ini.UpdateFile;
 for i:=1 to sl1.RowCount-1 do begin
  s:='';
  for j:=0 to sl1.ColCount-1 do s:=s+'#'+sl1.Cells[j,i];
  if sl1.Cells[0,i]<>'' then begin
   ini.WriteInteger('CHANN','count',i);
   ini.WriteString('CHANN',inttostr(i),s)
  end
 end;
 //
 ini.Free;
 OtherDrawer.Free;
 com.Connected:= false
end;

procedure Tmf.rec_bd;
begin //   //  
if en_bd.Checked then
 try
  bd.Append;
  //
  bd.FieldValues['ADR']:= chann4;
  bd.FieldValues['CHN']:= chann5;
  bd.FieldValues['VAL']:= chann6;
  bd.FieldValues['DATA']:= datetostr(date);
  bd.FieldValues['TIME']:= timetostr(time);
  bd.FieldValues['TYPE']:= buf[2];
  //
  bd.Post;
  application.ProcessMessages;
  bd.SaveToFile(bd.FileName); //?     
 except end
end;

procedure Tmf.cdpCustomStop(Sender: TObject; const Str: String;var Pos: Integer);
begin
 //-
 ti.Icon:= ti.Icons[1];
 packet(str);
 rec_bd;
 //-
 ti.Icon:= ti.Icons[0]
end;

//======================================
//DDE-
procedure Tmf.DATATMPokeData(Sender: TObject);
begin
 p3.Caption:= DATATM.Lines[0]
end;
procedure Tmf.to_pokedata(Sender: TObject);
begin
 if life then try
  with (Sender as TDdeServerItem) do
   //rec1.Lines:= DATAI[tag].Lines;
  //
 except end
end;
procedure Tmf.ch_create(col: integer);
var i:integer;
begin
 //  -chartFULL-
 life:=false;
 for i:= low(DATAI) to high(DATAI) do
  try DATAI[i].Destroy;except end;

 // -
 try setlength(DATAI,col);except end;
 for i:= low(DATAI) to high(DATAI) do begin
  try
  //
  DATAI[i]:= TDdeServerItem.Create(NIL);
  // 
  with DATAI[i] do begin
   tag:=i;
   serverconv:= GET;
   DATAI[i].OnPokeData:= to_pokedata;
   //
   Parent:= mf;
  end;
  except end;
 end;
 life:=true;
end;
//end DDE
//======================================

procedure Tmf.en_bdClick(Sender: TObject);
begin
 if en_bd.Checked then bd.FileName:= inputbox('  ?',':','bd')+'.cds'
end;

procedure Tmf.en_tcpClick(Sender: TObject);
begin
 tcp.Active:= en_tcp.Checked
end;
procedure Tmf.tcpClientRead(Sender: TObject; Socket: TCustomWinSocket);

 function delp(s: string): string;
 var Source, SourceEnd: PChar;
 begin
  Source   := Pointer(s);
  SourceEnd:= Source + Length(s);
  while Source < SourceEnd do begin
   case Source^ of
    #10: Source^:= #32;
    #13: Source^:= #32;
   end;
  Inc(Source)
  end;
  Result:= s
 end;

begin
 chann8:= delp(Socket.ReceiveText)
end;
procedure Tmf.tcpClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
 ErrorCode:= 0
end;

end.
