//------------------------------------------
//  -OpcServerCom-
//    MLink.OPC
//  SincIO & ASincIO
//
//  -ItemOPC- OPCDA v1.0(2) OPCDAServer20
//    
//     --
//
// *.dcu -  !
// 3  - 
// 32 -  - ()
//   -  !
//
// RAMEDIA-SOFT
// Author:   
// H-page: http://raxp.radioli.com
// C :  DCOM
//------------------------------------------
unit OpcServerCom;

interface

uses windows,SysUtils,forms,ActiveX,cport,cporttypes,ItemOPC,ServImpl,rwnd;

type
  TOPC = class(TObject)
  private
  public
end;

const //232-
      NUM = 0; {   ,   }
      CON = 1;
      RAT = 2;
      //MLink-
      MADR = 3;
      MCHN = 4;
      MVAL = 5;
      MGET = 6;
      //OPC-
      CH1   = 7;
      CH2   = 8;
      PIL   = 9;
      //Socket-
      SOCKC = 10;
      SOCKP = 11;
      SOCKD = 12;
      //TIME-
      TickH = 13;
      TimeH = 14;


{ TOPC }
var chann1,//  {}
    chann2,//  {}
    chann3,//pila                  {}
    chann4,//MADR
    chann5,//MCHN
    chann6,//MVAL
    chann7,//MGET
    chann8 //Sock
    :OleVariant;
    //MLink-
    buf: array [0..13] of byte;
    // OPC-
    clients:integer;

 //OPC-
 function  GetItemValue(index: integer):olevariant;
 procedure channels;
 procedure SetItemValue(index: integer; const Value: OleVariant);
 procedure PulseTimer;
 //MLink-
 procedure GetParms(seAddr,seFrom,seCount: integer);
 procedure SendParms(seAddr,seRight,seLeft: integer);
 procedure packet(str: string);

implementation
 uses mm;

//================================
//MLink-
procedure GetParms(seAddr,seFrom,seCount: integer);
var i: integer;
begin
 Buf[0] := $40;        // 
 Buf[1] := 1;          //   /  = 8+qq*4 
 Buf[2] := seAddr;     // 
 Buf[3] := 0;          // 
 Buf[4] := Lo(seFrom); //
 Buf[5] := Hi(seFrom); //
 Buf[6] := Lo(seCount);// 
 Buf[7] := Hi(seCount);// 
 Buf[8] := 0;          //
 Buf[9] := 0;          //
 Buf[10]:= 0;          //
 Buf[11]:= 0;          //
 Buf[12]:= 0;          //
 For i:=1 to 11 do
  Buf[12]:= Buf[12] Xor Buf[i];
 Buf[13]:=$2A;
 if mf.com.Connected then
  mf.com.Write(@Buf,14)
end;
//
procedure SendParms(seAddr,seRight,seLeft: integer);
var i:Integer;
begin
 Buf[0] := $40;         // 
 Buf[1] := 2;           //   
 Buf[2] := seAddr;      // 
 Buf[3] := 0;           // 
 Buf[4] := Lo(seRight); //
 Buf[5] := Hi(seRight); //
 Buf[6] := 1;           // 
 Buf[7] := 0;           // 
 Buf[8] := Byte(PChar(@seLeft)[0]); //
 Buf[9] := Byte(PChar(@seLeft)[1]); //
 Buf[10]:= Byte(PChar(@seLeft)[2]); //
 Buf[11]:= Byte(PChar(@seLeft)[3]); //
 Buf[12]:= 0;
 for i:=1 to 11 do
  Buf[12]:=Buf[12] Xor Buf[i];
 Buf[13]:=$2A;
 if mf.com.Connected then
  mf.com.Write(@Buf,14)
end;
//
procedure packet(str: String);
var i:integer;
begin
 ind(true,screen.Width-75,25,50,255); // 

 // -
 if length(str)=14 then begin
  for i:=1 To length(str) do begin
   buf[i]:= byte(char(str[i]));
   //txt.Items.Add(inttohex(buf[i],2));
  end;
  //
  chann4:= buf[3];        //
  chann5:= buf[5]+buf[6]; //
  chann6:= buf[9]+buf[10]+buf[11]+buf[12]; //

  //  -
  if buf[2]=1 then with mf do for i:=1 to sl1.RowCount-1 do begin
   //sendparms(chann4,chann5,chann6)
   {//top
   if buf[3]= adr1.Value then begin
    if chn= chn1.Value then SendParms(trunc(adr1.value),trunc(chn1.value),_chn1.Position);
    if chn= chn2.Value then SendParms(trunc(adr1.value),trunc(chn2.value),_chn2.Position)
   end; }
  end;

 //
 end;

 ind(false,0,0,0,0)
end;
//end MLink-
//================================

procedure channels;
begin
 // TraceMODE   :
 // VT_R4(4 byte real),
 // VT_I4(4 byte signed int),
 // VT_BSTR(8 binary string)
 // - VT_I4

 // -
 add('COMNUM',        VT_UI2);//varInteger
 add('COMCON',        VT_UI2);
 add('COMRAT',        VT_UI2);
 add('MLinkAdr',      VT_UI2);
 add('MLinkChann',    VT_UI2);
 add('MLinkValue',    VT_UI2);
 add('MLinkGet',      VT_UI2);
 add('OPCCH1',        VT_UI2);
 add('OPCCH2',        VT_UI2);
 add('OPCPIL',        VT_UI2);
 add('OPCSocketCON',  VT_UI2);
 add('OPCSocketPORT', VT_UI2);
 add('OPCSocketDATA', VT_UI2);
 add('TickCount',     VT_UI2); //VT_BSTR
 add('Time',          VT_BSTR)//varOleStr
end;

function getcomnum(s:string):integer;
begin
 result:= strtoint(copy(s,4,length(s)))
end;
//--->
function GetItemValue(index:integer):olevariant;
begin
 case index of
  //232-
  NUM  : Result:= getcomnum(mf.com.Port);
  CON  : Result:= longint(mf.com.Connected);
  RAT  : Result:= strtoint(cport.BaudRateToStr(mf.com.BaudRate));
  //MLink-
  MADR : Result:= chann4;
  MCHN : Result:= chann5;
  MVAL : Result:= chann6;
  MGET : Result:= chann7;
  //OPC-
  CH1  : Result:= chann2;
  CH2  : Result:= chann1;
  PIL  : Result:= chann3;
  //Socket-
  SOCKC:  Result:= longint(mf.tcp.Active);
  SOCKP:  Result:= mf.tcp.Port;
  SOCKD:  Result:= chann8;
  //
  TickH: Result:= integer(GetTickCount);
  TimeH: Result:= TimeToStr(Now);

  else result:= list[index].val;//  
 end
end;
//<---
procedure SetItemValue(index: integer; const Value: OleVariant);

 function addp(s: string): string;
 var Source, SourceEnd: PChar;
 begin
  s:=s+' ';
  Source   := Pointer(s);
  SourceEnd:= Source + Length(s);
  while Source < SourceEnd-1 do
   Inc(Source);
  Source^:= #13;
  Source^:= #10;
  Result:= s
 end;

var k: integer;
begin
 case index of
  //232-
  NUM : mf.com.Port:= 'COM'+inttostr(value);
  CON : try mf.com.Connected:= value; except mf.com.Connected:= false;end;
  RAT : try mf.com.BaudRate:= cport.StrToBaudRate(inttostr(value));except mf.com.BaudRate:=br9600;end;
  //MLink-
  MADR: chann4:= value;
  MCHN: chann5:= value;
  MVAL: begin chann6:= value; SendParms(chann4,chann5,chann6);end;
  MGET: begin chann7:= value; GetParms(chann4,chann5,1);end;
  //OPC-
  CH1 : chann1:= Value;
  CH2 : chann2:= Value;
  PIL : chann3:= Value;
  //Socket-
  SOCKC: try mf.tcp.Active:= Value; except mf.tcp.Active:= false;end;
  SOCKP: try mf.tcp.Active:=false; mf.tcp.Port:= Value; mf.tcp.Active:= mf.en_tcp.Checked;
         except end;
  SOCKD: begin
          chann8:= Value;
          for k:= 0 to mf.tcp.Socket.ActiveConnections-1 do
           mf.tcp.Socket.Connections[k].SendText(addp(Value))
         end;

  //list[index].val -    
 end
end;

// -
procedure PulseTimer;
var tr: integer;
begin
 try
  for tr:= low(theServers) to high(theServers) do
   if theServers[tr] <> nil then
    theServers[tr].TimeSlice(now); //  
 except end
end;

//  -OPCItems-
const
  ServerDesc   = 'MLink.OPC';
  ServerVendor = 'TOP-03M:  OPC  1.0 (2) 2004 RAMEDIA http://raxp.radioliga.com';

initialization
  chann1:= 0; chann2:= 0; chann3:= 0;
  chann4:= 0; chann5:= 0; chann6:= 0; chann7:= 0; chann8:= 0;
  //
  TOPCItems.Create(ServerDesc,ServerVendor);
finalization
end.

{
 MLink      
RS-232, RS-422, RS-485, Dial-Up, GSM/SMS
  T M,      ,   

  (HOST) 
    14 .

 :
 01234567890123
 @FAannqqttttS*

 
 F    (            8);
    ;
 a   ;
 nn   ;
 qq    ;
 tttt     (   );
 S       (XOR),   1  (.. @  )  11  .

 
/////////////////////////////
F=1    
  ( = 8+qq*4 ):
 012345 6789 01
 @FAann DDDD S*

 
 DDDD      FLOAT.
  DDDD=0xffffffff,   .

/////////////////////////////
F=7          
  ( = 8+qq*8 ):
 012345 6789 0123 01
 @FAann DDDD TTTT S*

 
 DDDD      FLOAT.  DDDD=0xffffffff,   .
 TTTT     (  C time()).

/////////////////////////////
F=2     
 :
 tttt   ;
 qq = 0.
  ( = 12 ):
 012345 6789 01
 @FAann xx00 S*

  xx -  .

/////////////////////////////
F=6     
 :
 tttt   ;
 qq = 0.
  ( = 14 ):
 012345 6789 0123
 @FAann xx00 xxS*

  xx   
}