//Globals-
// 
//
unit Globals;

{$IFDEF VER150}
{$WARN UNSAFE_CODE OFF}
{$ENDIF}

interface

uses
{$IFDEF VER140}
  Variants,
{$ENDIF}
{$IFDEF VER150}
  Variants,
{$ENDIF}
  Windows,Messages,SysUtils,Classes,Graphics,StdCtrls,Forms,Dialogs,Controls,
  ShellAPI,ActiveX,OPCDA,ItemOPC;

type
 itemIDStrings = record
  trunk,branch,leaf:string[255];
 end;

{type
  itemProps = record
    PropID: longword;
    tagname: string[64];
    dataType:integer;
  end; }

const
 IID_IUnknown: TIID = '{00000000-0000-0000-C000-000000000046}';

 {List: array[0..11] of itemProps =
  ((PropID: 5000; tagname: 'COMNUM';  dataType:VT_BSTR),
   (PropID: 5001; tagname: 'COMCON';  dataType:VT_BSTR),
   (PropID: 5002; tagname: 'COMRAT';  dataType:VT_BSTR),
   (PropID: 5003; tagname: 'MLinkAdr';  dataType:VT_BSTR),
   (PropID: 5004; tagname: 'MLinkChann';  dataType:VT_BSTR),
   (PropID: 5005; tagname: 'MLinkValue';  dataType:VT_BSTR),
   (PropID: 5006; tagname: 'MLinkGet';  dataType:VT_BSTR),
   (PropID: 5007; tagname: 'OPCCH1';  dataType:VT_BSTR),
   (PropID: 5008; tagname: 'OPCCH2';  dataType:VT_BSTR),
   (PropID: 5009; tagname: 'OPCPIL';  dataType:VT_BSTR),
   (PropID: 5010; tagname: 'TickCount';  dataType:VT_BSTR),
   (PropID: 5011; tagname: 'Time';  dataType:VT_BSTR)
   );   }


 //function ScanToChar(const theString:string; var start:integer;theChar:char):string;
 function ReturnPropIDFromTagname(const s1:string):longword;
 function ReturnTagnameFromPropID(PropID:longword):string;
 function CanPropIDBeWritten(i:longword):boolean;
 function ReturnDataTypeFromPropID(i:longword):integer;
 procedure DataTimeToOPCTime(cTime:TDateTime; var OPCTime:TFileTime);
 function ConvertVariant(cv:variant; reqDataType:TVarType):variant;

implementation

function ScanToChar(const theString:string; var start:integer;theChar:char):string;
var tempS:string;
    finish:boolean;
    nextloc,strLength: integer;
begin
 {$R-}
 strLength := length(theString);
 finish := false;
 SetLength(tempS,strLength);
 result := tempS;
 nextloc:= 1;
 while not finish do begin
  if (start < 256) and (theString[start] <> theChar) and
     (theString[start] <> chr(13)) and (start <= strLength) then
   begin
    tempS[nextloc]:= theString[start];
    nextloc:= succ(nextloc);
    start := succ(start);
   end else begin
    SetLength(tempS,nextloc-1);      {this sets the length of the string}
    finish:=true;                    {exit the loop}
    result:=tempS;                   {return the value}
   end;
 end;
{$R+}
end;

//   -
function ReturnPropIDFromTagname(const s1:string):longword;
var i:integer;
begin
 result:=0;
 for i:= low(List) to high(List) do
  if List[i].tagname = s1 then begin
   result:= List[i].PropID;
   Exit;
  end
end;

//   -
function ReturnTagnameFromPropID(PropID:longword):string;
var i:integer;
begin
 result:='';
 for i:= low(List) to high(List) do
  if List[i].PropID = PropID then begin
   result:= List[i].tagname;
   Exit;
  end
end;

//  -
function CanPropIDBeWritten(i:longword):boolean;
begin
 RESULT:= TRUE
 //i:= i - posItems[low(posItems)].PropID;
 //result:=boolean(i in [19..22])  //the test Test_Tag_X's
end;

//   ID
function ReturnDataTypeFromPropID(i:longword):integer;
var x:longword;
begin
 x:= i - List[low(List)].PropID;
 if (x <= high(List)) then result:= List[x].dataType
  else result:=VT_UI2
end;

procedure DataTimeToOPCTime(cTime:TDateTime; var OPCTime:TFileTime);
var sTime:TSystemTime;
begin
 DateTimeToSystemTime(cTime,sTime);
 SystemTimeToFileTime(sTime,OPCTime);
 LocalFileTimeToFileTime(OPCTime,OPCTime);
end;

function ConvertVariant(cv:variant; reqDataType:TVarType):variant;
begin
 try result:=VarAsType(cv,reqDataType)
 except
  on EVariantError do result:=DISP_E_TYPEMISMATCH;
 end
end;

end.
